// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package factory

import (
	"context"

	"github.com/aarondl/opt/null"
	"github.com/aarondl/opt/omit"
	"github.com/aarondl/opt/omitnull"
	"github.com/jaswdr/faker"
	"github.com/stephenafamo/bob"
	models "github/epith/302-backend-user/bob"
)

type GenreMod interface {
	Apply(*GenreTemplate)
}

type GenreModFunc func(*GenreTemplate)

func (f GenreModFunc) Apply(n *GenreTemplate) {
	f(n)
}

type GenreModSlice []GenreMod

func (mods GenreModSlice) Apply(n *GenreTemplate) {
	for _, f := range mods {
		f.Apply(n)
	}
}

// GenreTemplate is an object representing the database table.
// all columns are optional and should be set by mods
type GenreTemplate struct {
	ID      func() int
	Name    func() null.Val[string]
	AnimeID func() null.Val[int]

	r genreR
	f *Factory
}

type genreR struct {
	Anime *genreRAnimeR
}

type genreRAnimeR struct {
	o *AnimeTemplate
}

// Apply mods to the GenreTemplate
func (o *GenreTemplate) Apply(mods ...GenreMod) {
	for _, mod := range mods {
		mod.Apply(o)
	}
}

// toModel returns an *models.Genre
// this does nothing with the relationship templates
func (o GenreTemplate) toModel() *models.Genre {
	m := &models.Genre{}

	if o.ID != nil {
		m.ID = o.ID()
	}
	if o.Name != nil {
		m.Name = o.Name()
	}
	if o.AnimeID != nil {
		m.AnimeID = o.AnimeID()
	}

	return m
}

// toModels returns an models.GenreSlice
// this does nothing with the relationship templates
func (o GenreTemplate) toModels(number int) models.GenreSlice {
	m := make(models.GenreSlice, number)

	for i := range m {
		m[i] = o.toModel()
	}

	return m
}

// setModelRels creates and sets the relationships on *models.Genre
// according to the relationships in the template. Nothing is inserted into the db
func (t GenreTemplate) setModelRels(o *models.Genre) {
	if t.r.Anime != nil {
		rel := t.r.Anime.o.toModel()
		o.AnimeID = null.From(rel.ID)
		o.R.Anime = rel
	}

}

// BuildSetter returns an *models.GenreSetter
// this does nothing with the relationship templates
func (o GenreTemplate) BuildSetter() *models.GenreSetter {
	m := &models.GenreSetter{}

	if o.ID != nil {
		m.ID = omit.From(o.ID())
	}
	if o.Name != nil {
		m.Name = omitnull.FromNull(o.Name())
	}
	if o.AnimeID != nil {
		m.AnimeID = omitnull.FromNull(o.AnimeID())
	}

	return m
}

// BuildManySetter returns an []*models.GenreSetter
// this does nothing with the relationship templates
func (o GenreTemplate) BuildManySetter(number int) []*models.GenreSetter {
	m := make([]*models.GenreSetter, number)

	for i := range m {
		m[i] = o.BuildSetter()
	}

	return m
}

// Build returns an *models.Genre
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use GenreTemplate.Create
func (o GenreTemplate) Build() *models.Genre {
	m := o.toModel()
	o.setModelRels(m)

	return m
}

// BuildMany returns an models.GenreSlice
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use GenreTemplate.CreateMany
func (o GenreTemplate) BuildMany(number int) models.GenreSlice {
	m := make(models.GenreSlice, number)

	for i := range m {
		m[i] = o.Build()
	}

	return m
}

func ensureCreatableGenre(m *models.GenreSetter) {
}

// insertOptRels creates and inserts any optional the relationships on *models.Genre
// according to the relationships in the template.
// any required relationship should have already exist on the model
func (o *GenreTemplate) insertOptRels(ctx context.Context, exec bob.Executor, m *models.Genre) (context.Context, error) {
	var err error

	if o.r.Anime != nil {
		var rel0 *models.Anime
		ctx, rel0, err = o.r.Anime.o.create(ctx, exec)
		if err != nil {
			return ctx, err
		}
		err = m.AttachAnime(ctx, exec, rel0)
		if err != nil {
			return ctx, err
		}
	}

	return ctx, err
}

// Create builds a genre and inserts it into the database
// Relations objects are also inserted and placed in the .R field
func (o *GenreTemplate) Create(ctx context.Context, exec bob.Executor) (*models.Genre, error) {
	_, m, err := o.create(ctx, exec)
	return m, err
}

// create builds a genre and inserts it into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted model
func (o *GenreTemplate) create(ctx context.Context, exec bob.Executor) (context.Context, *models.Genre, error) {
	var err error
	opt := o.BuildSetter()
	ensureCreatableGenre(opt)

	m, err := models.Genres.Insert(ctx, exec, opt)
	if err != nil {
		return ctx, nil, err
	}
	ctx = genreCtx.WithValue(ctx, m)

	ctx, err = o.insertOptRels(ctx, exec, m)
	return ctx, m, err
}

// CreateMany builds multiple genres and inserts them into the database
// Relations objects are also inserted and placed in the .R field
func (o GenreTemplate) CreateMany(ctx context.Context, exec bob.Executor, number int) (models.GenreSlice, error) {
	_, m, err := o.createMany(ctx, exec, number)
	return m, err
}

// createMany builds multiple genres and inserts them into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted models
func (o GenreTemplate) createMany(ctx context.Context, exec bob.Executor, number int) (context.Context, models.GenreSlice, error) {
	var err error
	m := make(models.GenreSlice, number)

	for i := range m {
		ctx, m[i], err = o.create(ctx, exec)
		if err != nil {
			return ctx, nil, err
		}
	}

	return ctx, m, nil
}

// Genre has methods that act as mods for the GenreTemplate
var GenreMods genreMods

type genreMods struct{}

func (m genreMods) RandomizeAllColumns(f *faker.Faker) GenreMod {
	return GenreModSlice{
		GenreMods.RandomID(f),
		GenreMods.RandomName(f),
		GenreMods.RandomAnimeID(f),
	}
}

// Set the model columns to this value
func (m genreMods) ID(val int) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.ID = func() int { return val }
	})
}

// Set the Column from the function
func (m genreMods) IDFunc(f func() int) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.ID = f
	})
}

// Clear any values for the column
func (m genreMods) UnsetID() GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.ID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m genreMods) RandomID(f *faker.Faker) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.ID = func() int {
			return random[int](f)
		}
	})
}

func (m genreMods) ensureID(f *faker.Faker) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		if o.ID != nil {
			return
		}

		o.ID = func() int {
			return random[int](f)
		}
	})
}

// Set the model columns to this value
func (m genreMods) Name(val null.Val[string]) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.Name = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m genreMods) NameFunc(f func() null.Val[string]) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.Name = f
	})
}

// Clear any values for the column
func (m genreMods) UnsetName() GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.Name = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m genreMods) RandomName(f *faker.Faker) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.Name = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m genreMods) ensureName(f *faker.Faker) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		if o.Name != nil {
			return
		}

		o.Name = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m genreMods) AnimeID(val null.Val[int]) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.AnimeID = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m genreMods) AnimeIDFunc(f func() null.Val[int]) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.AnimeID = f
	})
}

// Clear any values for the column
func (m genreMods) UnsetAnimeID() GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.AnimeID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m genreMods) RandomAnimeID(f *faker.Faker) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.AnimeID = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m genreMods) ensureAnimeID(f *faker.Faker) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		if o.AnimeID != nil {
			return
		}

		o.AnimeID = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m genreMods) WithAnime(rel *AnimeTemplate) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.r.Anime = &genreRAnimeR{
			o: rel,
		}
	})
}

func (m genreMods) WithNewAnime(mods ...AnimeMod) GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {

		related := o.f.NewAnime(mods...)

		m.WithAnime(related).Apply(o)
	})
}

func (m genreMods) WithoutAnime() GenreMod {
	return GenreModFunc(func(o *GenreTemplate) {
		o.r.Anime = nil
	})
}
